#!/bin/sh
# the next line restarts using wish \
exec wish "$0" "$@"

# ============================================================================
# ̾      notepad.tcl Ģ
# Version   0.92, 06/27/2000
# ̾  mad_blue fuji@physics.s.chiba-u.ac.jp
# Home page http://physics.s.chiba-u.ac.jp/itohl/fuji/public_html/notepad/note.html
# ============================================================================
# С
proc ShowAbout {} {
    global w tcl_version tk_version
    set ver "Ver0.92,06/27/2000"
    set w(about) .about
    catch "destroy $w(about)"
    toplevel $w(about)
    wm title $w(about) "About This Program"
    wm resizable $w(about) 0 0
    set m1 $w(about).l1
    set m2 $w(about).l2
    set m4 $w(about).b1
    set m5 $w(about).l5
    set m6 $w(about).l6
    label $m1 -text "Ģ" -bd 5
    label $m2 -text $ver
    button $m4 -text "Ĥ" -command "destroy $w(about)"
    label $m5 -text "mad_blue, fuji@physics.s.chiba-u.ac.jp" -bd 5
    label $m6 -text " tcl$tcl_version tk$tk_version Ǥ" -bd 5
    pack $m1 $m2 $m5 $m6 $m4 -side top
}
# ʸʸĤ
proc NewFile {} {
    global w fname env
    $w(text) delete 1.0 end
    set fname ""
    wm title . "Notepad"
}
# ʸɤ߹
proc LoadFile {} {
    global w fname
    set esc $fname
    set ftypes {
        {"ƤΥե"    *}
        {"ƥʸ"    {.txt}  TEXT}
        {"HTMLʸ"  {.html .htm}  TEXT}
    }
    set fname [tk_getOpenFile -filetypes $ftypes -parent .] 
    if {$fname == ""} {     
	set fname $esc
	return
    } else {
	if { [ file readable $fname ] } {
	    set fileid [ open $fname "r" ]
	    set contents [ read -nonewline $fileid ]
	    close $fileid
	}
	$w(text) delete 1.0 end
	$w(text) insert 1.0 $contents
	$w(text) mark set insert 0.0
	set file [file tail $fname]
	wm title . "$file - Notepad"
    }
}
# ʸ¸
proc SaveFile {} {
    global w fname
    set esc $fname
    set ftypes {
        {"ƤΥե"    *}
        {"ƥʸ"    {.txt}      TEXT}
        {"HTMLʸ"  {.html .htm}  TEXT}
    }
    if {$fname==""} {
	set Untitled newfile
    } else {
	set Untitled [file tail $fname]
    }
    set fname [tk_getSaveFile -filetypes $ftypes \
        -parent . -initialfile $Untitled ]
    if {$fname == "" } {
 	set fname $esc       
	return
    } else {
	SaveFile2
	set file [file tail $fname]
	wm title . "$file - Notepad"
    }
}
# ¸
proc SaveFile2 {} {
    global w fname
    if {$fname==""} {SaveFile} else {
	set contents [ $w(text) get 1.0 end ]
	set fileid [ open $fname "w" ]
	puts -nonewline $fileid $contents
	close $fileid
	$w(text) configure -bg $w(defd)
	update
	$w(text) configure -bg $w(defc)
    }
}
# ԡ
proc ClipCopy {} {
    global w
    set owner [ selection own ]
    if { $owner == $w(text) } {
        clipboard clear
	catch {
	    clipboard append [selection get ]
	}
    }
}
# å
proc ClipCut {} {
    global w
    set owner [ selection own ]
    if { $owner == $w(text) } {
	clipboard clear
	catch {
	    clipboard append [ selection get ]
	    $w(text) delete sel.first sel.last
	}
    }
}
# ڡ
proc ClipPaste {} {
    global w
    catch { set clip [ selection get -selection CLIPBOARD ] }
    set idx [ $w(text) index insert ]
    set owner [ selection own ]
    if { $owner == $w(text) } {
	catch {
	    set idx [ $owner index sel.first ]
	    $w(text) delete sel.first sel.last
	}
    }
    catch { $w(text) insert $idx $clip }
}
# 
proc Delete {} {
    global w
    set owner [ selection own ]
    if { $owner == $w(text) } {
	catch { $w(text) delete sel.first sel.last }
    }
}
# 
proc Search {} {
    global w cashword
    set w(search) .search
    catch "destroy $w(search)"
    set x [winfo rootx .]
    set y [expr [winfo rooty .] -100]
    toplevel $w(search)
    wm title $w(search) "Search"
    wm resizable $w(search) 0 0
    wm geometry $w(search) 471x85+[expr ${x}+ 60]+[expr ${y}+250]
    #
    set w(stext) ""
    #
    set f1 $w(search)
    set f3 $f1.fra
    #
    label $f1.l1 -text "ʸ"
    entry $f1.e1 -bg white -selectbackground navy -selectf white
    button $f1.b1 -text 򸡺 -command "SearchText $f1.e1" -padx 13 -pady 4
    frame $f3 -bd 2 -height 75 -relief groove -width 125
    radiobutton $f3.r1 -text "" -variable w(sw) -value top -width 20
    radiobutton $f3.r2 -text "" -variable w(sw) -value bottom -width 20
    label $f1.l2 -borderwidth 0 -text 
    button $f1.b2 -text "󥻥" -padx 13 -pady 4\
	    -command "destroy $w(search)" -width 10
    #
    place $f1.l1 -x 5 -y 5 -width 89 -height 29 -anchor nw
    place $f1.e1 -x 95 -y 5 -width 268 -height 28 -anchor nw 
    place $f1.b1 -x 365 -y 5 -width 98 -height 34 -anchor nw
    place $f3 -x 20 -y 40 -width 335 -height 40 -anchor nw
    place $f3.r1 -x 0 -y 10 -anchor nw 
    place $f3.r2 -x 155 -y 10 -anchor nw
    place $f1.l2 -x 30 -y 35 -width 86 -height 19 -anchor nw
    place $f1.b2 -x 365 -y 45 -width 100 -height 34 -anchor nw
    $f3.r1 select
    #Х
    bind $w(search) <Return> "SearchText $f1.e1"
    bind $w(search) <Up>     "$f3.r2 invoke"
    bind $w(search) <Down>   "$f3.r1 invoke"
    bind $w(search) <Escape> "destroy $w(search)"
    #
    if {$cashword!=""} {
	$f1.e1 insert end $cashword
    }
    focus $f1.e1
}
# ƥȸ1
proc SearchText { widget } {
    global w cashword
    set stext [ $widget get ]
    set cashword $stext
    SearchText2 $stext
}
# ƥȸ2
proc SearchText2 {stext} {
    global w
    set slength [ string length $stext ]
    set w(stext) $stext
    set w(index) [$w(text) index insert] 
    switch $w(sw) {
	top    {
	 catch {
	  if {[selection own] == $w(text)} {
		set dumy [selection get]
		set w(index) {sel.first + 1 chars}
	  }
	 }
	 set idx [ $w(text) search -forward  $stext $w(index) end ]
	}
	bottom { 
	  catch {
	   if {[selection own] == $w(text)} {
	 	set dumy [selection get]   
		set w(index) sel.first
	   }
	  }
	 set idx [ $w(text) search -backward $stext $w(index) 1.0 ] 
	}
    }
    if { $idx != "" } {
	catch "$w(text) tag remove sel sel.first sel.last"
	$w(text) tag add sel $idx "$idx + $slength chars"
	switch $w(sw) {
	    top    { set idx "$idx + 1 char" }
	    bottom { set idx "$idx" }
	}
	$w(text) mark set insert $idx
	$w(text) see $idx
	}
}
#򸡺
proc SearchNext {} {
    global cashword
    if {$cashword==""} {Search} else {
	catch { SearchText2 $cashword }
    }
}
# ˥塼С
proc MakeMenu {} {
    global w env
    # ˥塼Сѥե졼
    set w(menu) .menu
    frame $w(menu) -bd 0
    pack $w(menu) -side top -fill x
    # ˥塼
    set w(file) $w(menu).file
    set w(edit) $w(menu).edit
    set w(search) $w(menu).search
    set w(ime2) $w(menu).ime2
    set w(help) $w(menu).help

    #
    menubutton $w(file) -text "ե" -menu $w(file).m
    menubutton $w(edit) -text "Խ"     -menu $w(edit).m
    menubutton $w(search) -text ""   -menu $w(search).m
    menubutton $w(help) -text "إ"   -menu $w(help).m  
    #
    pack $w(file) $w(edit) $w(search) $w(help) -side left
    # ե
    menu $w(file).m -tearoff no
    $w(file).m add command -label  -command NewFile  \
	-activeb navy -activef white
    $w(file).m add command -label  -acc Ctrl+L -command LoadFile \
	-activeb navy -activef white
    $w(file).m add command -label ¸ -acc Ctrl+S -command SaveFile2 \
	-activeb navy -activef white
    $w(file).m add command -label ̾դ¸ -command SaveFile \
	-activeb navy -activef white
    $w(file).m add separator
    $w(file).m add command -label ¹ -command PrintText \
	    -activeb navy -activef white
    $w(file).m add separator
    $w(file).m add command -label Ģνλ -acc ESC -command exit     \
	-activeb navy -activef white
    # Խ
    menu $w(edit).m -tearoff no
    $w(edit).m add command -label ڤ -acc Ctrl+X -command ClipCut   \
	-activeb navy -activef white
    $w(edit).m add command -label ԡ -acc Ctrl+C -command ClipCopy  \
	-activeb navy -activef white
    $w(edit).m add command -label Žդ -acc Ctrl+Y -command ClipPaste \
	-activeb navy -activef white
    $w(edit).m add command -label  -acc Del -command Delete \
	-activeb navy -activef white
    $w(edit).m add separator
    $w(edit).m add command -label ٤ -acc {Ctrl+/} \
	-activeb navy -activef white -command "$w(text) tag add sel 1.0 end"
    # 
    menu $w(search).m -tearoff no
    $w(search).m add command -label  -command Search \
	-activeb navy -activef white
    $w(search).m add command -label 򸡺 -acc F3 -command {set w(sw) top; SearchNext} \
	-activeb navy -activef white
    # إ
    menu $w(help).m -tearoff no
    $w(help).m add command -label "С" -command ShowAbout \
	-activeb navy -activef white
    # ݥåץåס˥塼
    menu .popup -tearoff no
    .popup add command     -label "ڤ"  -command ClipCut   \
	-activeb navy -activef white  
    .popup add command     -label "ԡ"    -command ClipCopy  \
	-activeb navy -activef white
    .popup add command     -label "Žդ"  -command ClipPaste \
	-activeb navy -activef white
    .popup add command     -label ""  -command Delete \
	-activeb navy -activef white
}
#ץ
proc PrintText {} {
    global w env
    set i [catch {exec lpr -P$env(PRINTER) << [ $w(text) get 1.0 end ]}] 
    
}
# ƥ
proc MakeText {} {
    global w tcl_version
    # ƥȤΥե졼
    frame $w(main) -bd 0
    pack $w(main) -side top -fill both -expand yes
    # ƥȤȥС
    text $w(text) -bg white -yscrollcommand "$w(main).scrl set" \
	    -selectba navy -selectf white
    catch {
	if {$tcl_version<8.0} {
	    $w(text) config -font -*-fixed-medium-r-normal--16-*-iso8859-1 \
		    -kanjifont -*-fixed-medium-r-normal--16-*-jisx0208.1983-0
	} else {
	    font create kanjifont -compound { r16 kanji16 }
	    $w(text) config -font kanjifont
	}
    }
    scrollbar $w(main).scrl -command "$w(text) yview" -width 20 
    #
    pack $w(main).scrl -side right -fill y
    pack $w(text) -side left -fill both -expand yes
    # ݥåץåץ˥塼ΰ٤ΥХɽ
    bind $w(text) <Button-3> {
	set x [ expr [ winfo rootx %W ] + %x ]
	set y [ expr [ winfo rooty %W ] + %y ]
	tk_popup .popup $x $y
    }
}
#ˤۤ󤴤꤫
proc JEchange {} {
	button .ja -text  -command {catch "kinput_start $w(text) over"}
	button .en -text  -command {catch "kanjiInput end $w(text)"}
	pack .en .ja -side right
}
#ư
proc Start {} {
    global w argc argv fname
    if {$argc == 2} {
	if {[regexp {\+[0-9]+$} [lindex $argv 0] ] == "1"} {
		set argc 1
		set number [string trimleft [lindex $argv 0] +]
		set argv [lindex $argv 1]
	}
    } 
    if {$argc == 1} { 
	set fname [lindex $argv 0]
	catch {
	    set fileid [ open $fname "r" ]
	    set contents [ read -nonewline $fileid ]
	    close $fileid
	    $w(text) insert 1.0 $contents
	    $w(text) mark set insert 0.0
	    catch {
		$w(text) mark set insert $number.0
	        $w(text) see $number.0
	    }
	}
	wm title . "$fname - Notepad"
    }
    if {$argc >= 2} {puts ¿;exit} 
}
# --------
#  ᥤ
# --------
wm title . "Notepad"
set w(main) .frame
set w(text) $w(main).txt
MakeMenu
MakeText
#JEchange
set fname ""
set cashword ""
Start
bind . <Control-s> SaveFile2
bind . <Escape> exit
bind $w(text) <F3> {set w(sw) top ; SearchNext}
bind $w(text) <Shift-F3> {set w(sw) bottom ; SearchNext}
bind . <Control-l> LoadFile
bind $w(text) <Mode_switch> {catch {kinput_start $w(text) over}    }
bind . <F1> {tkMbPost $w(file) %X %Y}
bind all <F10> ""
focus $w(text)
#set auto_path [linsert $auto_path 0 /home51/s/y6s2001/tcl/AUTO]
#ޥ
catch { source $env(HOME)/.notepadrc}
#
set w(defc) [$w(text) cget -bg]
set w(defd) [$w(text) cget -fg]

